var Event = require('compose-toolbox').event

function numberInputOnly(event) {
  var key = event.keyCode,
      numberKeys = ( 47 < key && key < 58 ),
      numPadKeys = ( 95 < key && key < 106 ),
      decimals   = ( key == 110 || key == 190 ),
      modifiers  = ( Event.key.alt || Event.key.shift ),
      inputKey   = !(( key < 46 && key != 32 ) || Event.key.command ),
      numInput   = (( numberKeys || numPadKeys || decimals ) && !( modifiers && 47 < key ) )

  if ( !numInput && inputKey ) {
    event.preventDefault()
    event.stopPropagation()
  }
}

// Prevent non numeric input on input type of number
Event.on( document, 'keydown', 'input[type=number]', numberInputOnly )
