var toolbox = require('compose-toolbox'),
    Event = toolbox.event,
    convert = require('../modules/unit-converter'),
    formUp = require( 'compose-form-up' )

function setup(el) {
  el.dataset.unitKey = String(Math.random()).split('.')[1]

  el.parentElement.insertAdjacentHTML( 'afterend', setupInput(el) )
  el.insertAdjacentHTML( 'afterend', setupSelect(el) )

  var select = el.nextElementSibling

  setValue(el)
  // Add some padding between input entry and select, based on width of select
  el.style.paddingRight = (el.offsetWidth - select.offsetLeft + 10) + 'px'
}

function randID () {
  return Math.random().toString(36).substring(3)
}

function setupSelect(el) {
  var units = ['B', 'KB', 'MB', 'GB', 'TB'],
      selectId = `input-unit-${randID()}`,
      select = `<span class='input-unit unit-select'><select class='input-unit-name' id='${selectId}' tabindex='-1' aria-label='units' data-default='${el.dataset.unit}' data-initial-value='${el.dataset.unit}' data-unit-select='${el.dataset.unitKey}'>`,
      selected = el.dataset.unit,
      wrapper = toolbox.getClosest( el, 'label' ),
      checked

  units.forEach(function(unit) {
    checked = ( (selected == unit) ? ' selected' : '' )
    select += `<option${checked}>${unit}</option>`
  })

  if ( wrapper ) {
    var defaultInput = wrapper.querySelector('[data-restore-default]')
    if ( defaultInput ) defaultInput.dataset.restoreDefault += `, #${selectId}`
  }

  select = select + "</select></span>"

  return select
}

function setupInput(el) {
  name = el.name
  el.name = name + '_value'
  return '<input data-unit-input="'+el.dataset.unitKey+'" type="hidden" name="'+name+'">'
}

function setValue(el) {
  el = el.target || el
  var input = document.querySelector('[data-unit-input="'+el.dataset.unitKey+'"]')
  var select = document.querySelector('[data-unit-select="'+el.dataset.unitKey+'"]')
  input.value = convert(el.value, select.value, el.dataset.unit).value
}

function unitChange(event) {
  var unitKey = event.target.dataset.unitSelect
  var el = document.querySelector('[data-unit-key="'+unitKey+'"]')
  setValue(el)
}

Event.change( function() {
  toolbox.each( document.querySelectorAll( '[data-unit]' ), setup )
})

Event.on(document, 'input', '[data-unit]', setValue)
Event.on(document, 'input', '[data-unit-select]', unitChange)
