var toolbox = require('compose-toolbox'),
    Event = toolbox.event

function disableRadioGroupInputs ( input ) {
  var input = ( input.target || input )
  var inputName = input.name
  var radioGroup = document.querySelectorAll('input[name=' + inputName + ']') 
  
  radioGroup.forEach(function(radioInput) {
    var radioBlock = toolbox.getClosest( radioInput, '.radio-block' )
    if (radioBlock) {
      var radioSecondaryInputs = radioBlock.querySelectorAll('input[type=text]')
      radioSecondaryInputs.forEach(function(radioSecondaryInput) {
        if (radioInput.checked === false) {
          radioSecondaryInput.setAttribute("disabled", "");
        } else {
          radioSecondaryInput.removeAttribute("disabled", "");              
        }
      })
    }
  })
}

Event.change( function() {
  toolbox.each( document.querySelectorAll('input[type=radio]'), disableRadioGroupInputs )
})

Event.on( document, 'input', 'input[type=radio]', disableRadioGroupInputs )