var Event = require( 'compose-toolbox' ).event

function autoSizeTextarea( textarea ) {
  var parent = textarea.parentElement

  if ( textarea.value == '' ) return
  if ( parent.classList.contains('input-wrapper') ) {

    parent.style.height = textarea.style.height
    var offset = textarea.offsetHeight - textarea.clientHeight
    textarea.style.height = 'auto'
    var newHeight = ( textarea.scrollHeight + offset )
    var maxHeight = window.innerHeight * .95

    if ( newHeight < maxHeight )
      textarea.style.height = newHeight + 'px'
    else
      textarea.style.height = maxHeight + 'px'

    parent.style.height = 'auto'
  }
}

Event.change(function(){
  var textareas = document.querySelectorAll('textarea')
  Event.delay( function(){ Array.prototype.forEach.call(textareas, autoSizeTextarea) } )
})

Event.on(document, 'keyup toggler:show', 'textarea', function(event){
  autoSizeTextarea(event.currentTarget)
})


