var Event = require('compose-toolbox').event

// Check if child select matches parent selected option
function matchParentSelected(child,parentOption) {
  for (var i=0; i<child.length; i++){
    // If child select optgroup does not match, hide options
    if (child[i].dataset.tierParent !== parentOption) {
      child[i].style.display = 'none';
    } else {
      child[i].style.display = 'block';
    }
  }
}

// Removing optgroup to hide select section labels
function setup (el) {
  el.className += " select-child";
  var tierSelector = el.getAttribute('tier_parent');
  var tierParent = document.getElementById(tierSelector);
  tierParent.className += " select-parent";
}
  
function removeOptgroupWrapper (el) {
  // Get label of each optgroup
  var childLabels = el.label;
  var options = el.getElementsByTagName('option');
  // For each option in an optgroup, add the data-tier-parent
  // attribute and remove the optgroup wrapper
  Array.prototype.forEach.call(options, option => {
    option.setAttribute('data-tier-parent', childLabels);
  })
  el.outerHTML = el.innerHTML;
}

function checkMatch (el) {
  // Check if any options match the select parent label
  var childOptions = el.querySelectorAll('[data-tier-parent]');
  var tierSelector = el.getAttribute('tier_parent');
  var tierParent = document.getElementById(tierSelector);
  var parentSelected = tierParent.selectedOptions[0].label;
  matchParentSelected(childOptions, parentSelected)
}

function test (el) {
    var children = document.querySelectorAll('select[tier_parent="' + el.id + '"]');
    
    children.forEach(function(child) {
      child.selectedIndex = 0;
      // console.log("Logging change");
      checkMatch(child)
      while (child.classList.contains('select-parent')) {
        var nestedChild = document.querySelector('[tier_parent="' + child.id + '"]');
        nestedChild.selectedIndex = 0;
        child = nestedChild;
      }
    })
    // var parentSelected = parent.selectedOptions[0].label;
  }
Event.ready(function(){
  var tierChild = document.querySelectorAll('select[tier_parent]');
  tierChild.forEach(setup)
  tierChild.forEach(checkMatch)
})

Event.ready(function(){
  var tierOptgroup = document.querySelectorAll('select[tier_parent] optgroup');
  tierOptgroup.forEach(removeOptgroupWrapper)
})

Event.on(document, 'change', '.select-parent', function(event){
  test(event.currentTarget)
})