var event = require( 'compose-toolbox' ).event

// Public API function
var clipboard = function() {

  // Listen for click events
  event.on( document, 'click', '[data-copy-target]', copy )

  // Copy to clipboard handler
  function copy( event ) {

    // Assignment
    var copyTrigger = event.currentTarget,
        copyElement = document.querySelector( copyTrigger.dataset.copyTarget )

    // Prevent default behavior
    event.preventDefault()

    // Is the element selectable?
    if ( copyElement && copyElement.select ) {

      // Select text
      copyElement.select();

      // Give it a try
      try {

        // Copy text
        document.execCommand( 'copy' )

        // Blur the element
        copyElement.blur()

        // Trigger copied state
        copyTrigger.classList.add( 'copied' )

        // Remove copied state after a couple seconds
        setTimeout( function() {
          copyTrigger.classList.remove( 'copied' )
        }, 2000 )

      // If it borks
      } catch ( err ) {

        // Go nuclear
        alert( 'please press Ctrl/Cmd+C to copy' )

      }

    }

  }
}

module.exports = clipboard
