const unitsTable = {
  bit: 1,
  byte: 8,
  kilobyte: 1000 * 8,
  megabyte: 1000 * 1000 * 8,
  gigabyte: 1000 * 1000 * 1000 * 8,
  terabyte: 1000 * 1000 * 1000 * 1000 * 8  
}
const aliases = {
  b: 'bit',
  B: 'byte',
  KB: 'kilobyte',
  MB: 'megabyte',
  GB: 'gigabyte',
  TB: 'terabyte'
}

function shortUnit(unit) {
  for (let key in aliases) {
    if (aliases[key] == unit) unit = key
  }

  return unit
}
function longUnit(size, unit) {
  return pluralize(size, unit.charAt(0).toUpperCase() + unit.slice(1))
}

function alias(unit) {
  return aliases[unit] || unit.toLowerCase()
}

function pluralize(val, unit) {
  if ( val != 1 ) unit += 's'
  return unit
}

function convert(num, as, to) {
  var to     = alias(to),
      base   = unitsTable[alias(as)],
      target = unitsTable[to]
  var num    = (num * base / target)
  
  
  var conversion = { 
    value: num,
    unit:  shortUnit(to),
    long:  longUnit(num, to)
  }
  return conversion
}

module.exports = convert
