// Icons must come before event registrations
require( './_icons' ) // Import svg icons (from Esvg)
var esvg = require( './_esvg' )

var toolbox    = require( 'compose-toolbox' )
var timeToggle = require( 'compose-time-toggle' ) // Switch time elements between local and UTC
var toggler    = require( 'compose-toggler' )
var formUp     = require( 'compose-form-up' )
var dialog     = require( 'compose-dialog' )
var ajax       = require( 'superagent' )
var clipboard  = require( './modules/clipboard' )
var notify     = require( './modules/notify' )
var event      = toolbox.event

event.scroll.disablePointer()        // disable pointer events on scroll for performance (to avoid extra repaints)
event.resize.disableAnimation()        // disable pointer events on scroll for performance (to avoid extra repaints)
clipboard();

require( './enhancements/flash-messages' )
require( './enhancements/form-submit-helpers' )
require( './enhancements/input-number-only' )
require( './enhancements/input-unit' )
require( './enhancements/link-here' )
require( './enhancements/radio-groups' )
require( './enhancements/textarea-expand' )
require( './enhancements/tiered-select' )

event.change( timeToggle.timeago.setup )
formUp.diff.watch()
formUp.steppedNumberInput.watch()
formUp.stepLabels.watch()
formUp.slider.setup()

// Public API object
window.Tungsten = module.exports = toolbox.merge( {
  ajax        : ajax,
  form        : formUp,
  toggler     : toggler,
  clipboard   : clipboard,
  notify      : notify,
  esvg        : esvg,
  timeToggle  : timeToggle,
  dialog      : dialog
}, toolbox )
