module Tungsten
  class ErrorsController < ::ApplicationController
    include Gaffe::Errors
    skip_before_action :verify_authenticity_token

    # Override 'error' layout
    layout 'tungsten/errors'

    # Render the correct template based on the exception "standard" code.
    # Eg. For a 404 error, the `errors/not_found` template will be rendered.
    def show
      respond_to do |format|
        format.html do
          # Here, the `@exception` variable contains the original raised error
          render "tungsten/errors/#{@rescue_response}", status: @status_code
        end

        format.json do
          render json: { errors: @rescue_response }, status: @status_code
        end
      end
    end
  end
end
