module Tungsten
  module FormForHelper
    class TungstenFormBuilder
      def initialize(template, values, errors)
        @template = template
        @values = values
        @errors = errors
      end

      def method_missing(method, field_name, options = {}, &block)
        @template.send(method, field_name, options.merge({
          value: @values[field_name],
          errors: @errors[field_name]
        }.compact), &block)
      end
    end

    def tungsten_form_for(values, options = {}, &block)
      errors = options.delete(:errors) || values.try(:errors) || {}

      body = capture TungstenFormBuilder.new(self, values, errors), &block
      form_tag_with_body options, body
    end
  end
end
