module Tungsten
  module NoticeHelper
    def warning_notice( title=nil, options={}, &block )
      options[:type] = :warning
      notice( title, options, &block )
    end

    def inline_notice( title=nil, options={}, &block )
      options[:type] = :'inline-notice'
      notice( title, options, &block )
    end

    def inline_warning_notice( title=nil, options={}, &block )
      options[:type] = :'inline-warning-notice'
      notice( title, options, &block )
    end

    def card_notice( title=nil, options={}, &block )
      options[:type] = :'card-notice'
      notice( title, options, &block )
    end

    def card_warning_notice( title=nil, options={}, &block )
      options[:type] = :'card-warning-notice'
      notice( title, options, &block )
    end

    def notice( title=nil, options={}, &block )
      if title.is_a? Hash
        options = title 
        title = nil
      end

      options[:class] = "notice #{options[:class]}".strip
      options[:class] << " #{options[:type]}" if options[:type]

      header = content_tag( :h4, class: 'notice-title' ) { title }

      if options.delete(:dismiss)
        options[:id] = "notice-#{SecureRandom.hex(5)}"
        header = content_tag( :header, class: 'notice-header' ) {
          concat header
          concat icon_button 'x-circle', class: 'dismiss-notice', toggle: "##{options[:id]}", clear: true
        }
      end

      content_tag( :div, options ) {
        concat header
        concat content_tag( :div, class: 'notice-content' ) {
          capture(&block).html_safe if block_given?
        }
      }
    end
  end
end
