module Tungsten
  module SectionHelper
    class Section < Tungsten::Helper

      def initialize( title = nil, options = {} )
        if title.is_a? Hash
          @options = title
          @title = nil
        else
          @options = options
          @title = title
        end

        @id = @options[:id]
      end

      def display( body )
        content_tag( :section, @options ) do
          @options[:class] = "app-section #{@options[:class]} #{"hidden" if @options.delete(:hidden)}".strip
          concat title( @title ) if @title
          concat body
        end
      end

      def title( text = nil, options = {}, &block )
        options[:class] = "app-section-title #{options[:class]}".strip

        if text
          text = content_tag( :a, text, href: "##{@id}", class: 'app-section-title-anchor' ) unless @id.nil?
          text = heading(text)
        end

        tag = content_tag( :div, options ) {
          concat text
          concat content_tag( :div, class: 'app-section-description', &block) if block_given?
        }
      end

      def heading( text, options={})
        options[:class] ||= ''
        options[:class] << ' app-section-heading'
        content_tag( :h2, text, options )
      end

      def content( options={}, &block )
        content_tag( :div, class: 'app-section-content', &block )
      end
    end
  end
end
