module Tungsten
  module TopologyGridHelper
    def topology_grid(name, components=2, options={}, &block)
      
      options[:class] = "topology-grid-wrapper #{options[:class]} #{ 'disabled' if options[:disabled] }".strip
      options[:'data-track-input-state'] = "##{name}-slider"
      disabled = options.delete(:disabled)
      
      label = block_given? ? capture(&block) : options.delete(:label)

      content_tag( :div, options){
        concat content_tag( :div, class: "topology-grid"){
          components.times do
            concat content_tag( :div, class: "component") {}
          end
        }
        
        if options[:step_label]
          concat tag( :span, 'data-step-label': "#{options[:step_label]}", class: "topology-grid-label")
          options.delete(:step_label)
        elsif label
          concat content_tag( :span, class: "topology-grid-label"){ label }
        end
      }

    end
  end
end
