Gem.loaded_specs['tungsten'].dependencies.each do |d|
  require d.name
end

require 'tungsten/version'
require 'tungsten/helper'

module Tungsten
  class Plugin < Cyborg::Plugin
  end
end

module Site
  extend self

  mattr_accessor :title
  self.title = "Tungsten"

  # Map vars from app into engine
  def setup
    yield self
  end

  def config_data
    @config_data ||= Cyborg.config_data
  end

  def deployment_icon
    @deployment_icon ||= Esvg.find_symbol('icons/deployment')
  end
end

Cyborg.register(Tungsten::Plugin, gem: 'tungsten', engine: 'tungsten') do
  initializer 'gaffe' do
    Gaffe.configure do |config|
      config.errors_controller = 'Tungsten::ErrorsController'
    end

    Gaffe.enable!
  end
end
